#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "socket.h"
#include "Obj.h"
#include "Sock.h"

#define SOCK_BUFFER_SIZE 1024

struct _Sock {
  int sockt;
  int offset;
  int size;
  char buffer[SOCK_BUFFER_SIZE];
};

Sock Sock_Create(int sockt)
{
  Sock sock;

  sock = malloc(sizeof(*sock));
  memset(sock, 0, sizeof(*sock));

  sock->sockt = sockt;
  sock->offset = 0;
  sock->size = 0;

  return sock;
}

Sock Sock_Destroy(Sock sock)
{
  if (sock->sockt >= 0)
    close(sock->sockt);
  if (sock) free(sock);
  return NULL;
}

int SockList_AddSock(ObjList list, int sockt)
{
  Sock sock;
  sock = Sock_Create(sockt);
  ObjList_InsertObjToEnd(list, sock, (ObjDestructor)Sock_Destroy);
  return 0;
}

char **SockList_ReadLine(ObjList list, int wait_usec)
{
  Sock sock;
  ObjListData obj;
  char **argv;

  for (obj = ObjList_GetStart(list);
       !ObjList_IsEndEdge(list, obj);
       obj = ObjListData_GetNext(obj)) {
    sock = (Sock)ObjListData_GetObj(obj);
    argv = socket_readline(&sock->sockt, &sock->offset, &sock->size,
			   SOCK_BUFFER_SIZE, sock->buffer, wait_usec);
    if (argv)
      return argv;
    if ((sock->sockt < 0) && (sock->size == 0)) {
      obj = ObjList_DeleteObjToPrev(list, obj);
    }
  }
  return NULL;
}
